package jam;

import java.lang.*;
import java.net.*;

public class Conference extends Object
{
   String conference_name;	// Name of this Conference
   int application;		// The application to be refered

   String local_host;	// The local hostname
   String dest_host;	// The hostname of the destination host
   String audio_port;	// The port for audio transmission
   String video_port;	// The port for video transmission

   boolean is_udp;	// Get measurements for UDP protocol
   boolean is_tcp;	// Get measurements for TCP protocol
   boolean is_rtp;	// Get measurements for RTP protocol
   boolean is_ip;	// Get measurements for IP protocol
   boolean is_atm;	// Get measurements for ATM layer

   

   public void set_name( String s ) { conference_name = s ; }
   public String get_name() { return conference_name ; }

   public void set_application( int a ) { application = a ; }
   public int get_application() { return application ; }

   public void set_source( String host ) { local_host = host ; }
   public String get_source() { return local_host ; };

   public void set_destination( String host ) { dest_host = host ; }
   public String get_destination() { return dest_host ; };

   public void set_video( String v ) { video_port = v ; }
   public String get_video() { return video_port ; };

   public void set_audio( String a ) { audio_port = a ; }
   public String get_audio() { return audio_port ; };

   public void set_udp( boolean b ) { is_udp = b ; }
   public boolean get_udp() { return is_udp ; };

   public void set_tcp( boolean b ) { is_tcp = b ; }
   public boolean get_tcp() { return is_tcp ; };

   public void set_rtp( boolean b ) { is_rtp = b ; }
   public boolean get_rtp() { return is_rtp ; };

   public void set_ip( boolean b ) { is_ip = b ; }
   public boolean get_ip() { return is_ip ; };

   public void set_atm( boolean b ) { is_atm = b ; }
   public boolean get_atm() { return is_atm ; };



   public Conference() 
   {
     // The default conference with no specified parameters

     set_name( "" );

     // Hence, only MBone tools are supported, this value does not change
     set_application( Config.APPLICATION_MBONE );

     // Set the local hostname
     InetAddress local = null;
     try {
       local = InetAddress.getLocalHost( );
       set_source( local.getHostName() );        
     }
     catch ( Exception e )
      { 
        System.out.println("Couldn't get IP address for local host "); 
        set_source("");
      }

     set_destination("");
     set_video("3456");
     set_audio("3458");
     set_udp( false );
     set_tcp( false );
     set_rtp( false );
     set_ip( false );
     set_atm( false );
   }

}

