package jam;

import java.io.* ;
import java.lang.* ;


 // This class is used to support File access, giving read/write
 // methods to read conference paramters out of a file and to write
 // conference parameters into a specified file


public class ConferenceFileHandler extends Object
{
  ConferenceMenu parent;		// The calling menu class
  RandomAccessFile conf_file; 		// The configuration file

 // The constructor
 public ConferenceFileHandler( ConferenceMenu par )
 {
  parent = par;
 }

 
 // Opens an existing file. 
 public boolean open( String path, String name ) 
 {
   try { 
    conf_file = new RandomAccessFile( path+name, "rw" );
    return true;
   } catch ( IOException e ) { 
    System.out.println("Couldn't open file "+ path+name);
    return false; 
   }

 }


 // Closes a conference file at the end of a session
 public void close()
 {
   if ( conf_file != null ) {
    try { 
     conf_file.close();
    } catch ( IOException e ) { }
   }
 }


 // Reads all conference parameters out of a conference file
 public boolean read( ) 
 { 
  Conference c = new Conference();
  try { 
     c.set_name( conf_file.readUTF());
     c.set_application( conf_file.readInt());
     c.set_source(conf_file.readUTF());
     c.set_destination(conf_file.readUTF());
     c.set_video(conf_file.readUTF());
     c.set_audio(conf_file.readUTF());
     c.set_atm( conf_file.readBoolean());
     c.set_ip(  conf_file.readBoolean());
     c.set_tcp( conf_file.readBoolean());
     c.set_udp( conf_file.readBoolean());
     c.set_rtp( conf_file.readBoolean());

    } 
   catch ( IOException e ) {
     return false; 
   }   
  parent.set_conference( c );
  return true;
 }


 // Writes conference parameters back to a conference file
 public void write( Conference conf ) 
 {
  try 
   {
     conf_file.seek( 0 );
     conf_file.writeUTF(conf.get_name());
     conf_file.writeInt(conf.get_application());
     conf_file.writeUTF(conf.get_source());
     conf_file.writeUTF(conf.get_destination());
     conf_file.writeUTF(conf.get_video());
     conf_file.writeUTF(conf.get_audio());
     conf_file.writeBoolean(conf.get_atm());
     conf_file.writeBoolean(conf.get_ip());
     conf_file.writeBoolean(conf.get_tcp());
     conf_file.writeBoolean(conf.get_udp());
     conf_file.writeBoolean(conf.get_rtp());

   } catch ( IOException e ) { }
 }
}
 