package jam;

import java.awt.*;
import java.io.*;


public class ConferenceMenu extends Frame
{
    FileDialog openDialog, saveDialog;
    ConferenceFileHandler conFileHan;
    ProcessHandler procHan;
    Conference act;

    // The different RuntimeHandlers
    RuntimeHandler atm_rh,ip_rh, udp_rh_v, udp_rh_a, 
                   tcp_rh, rtp_rh_a, rtp_rh_v;

    public ConferenceMenu() 
     {
        setLayout( new BorderLayout() );
        setTitle("JAM   -  Conference Menu");
        Panel p1 = new Panel();
        p1.setLayout(new FlowLayout());
        add("South",p1);
        p1.add(new Button("Start Conference"));
        p1.add(new Button("Stop Conference"));

        MenuBar mb;
        Menu m, sm;

        mb = new MenuBar();

        m = new Menu("File");

	        m.add("Open");
        	m.add("Save");
	        //m.add("Save as");
	        m.addSeparator();
	        m.add("Quit");

        mb.add(m);

        m = new Menu("Conference");

	        m.add("New");
	        m.add("Edit");
        	m.add("Close");
	
        mb.add(m);

        m = new Menu("Statistics");

	        //m.add("ATM-Layer");

		Menu ip_menu = new Menu("IP-Layer");
		        ip_menu.add("IP-Interarrival-Time");
		        ip_menu.add("IP-Lossrate");
		        ip_menu.add("IP-Bandwidth-Usage");
	        m.add(ip_menu);


		//m.add("TCP-Layer");

	        Menu udp_menu = new Menu("UDP-Layer");
		        Menu udp_menu_audio = new Menu("UDP-Audio");
		        	udp_menu_audio.add("UDP-Interarrival-Time (Audio)");
		        	udp_menu_audio.add("UDP-Bandwidth-Usage (Audio)");
	        	udp_menu.add(udp_menu_audio);

	        	Menu udp_menu_video = new Menu("UDP-Video");
		        	udp_menu_video.add("UDP-Interarrival-Time (Video)");
		        	udp_menu_video.add("UDP-Bandwidth-Usage (Video)");
	        	udp_menu.add(udp_menu_video);
	        m.add(udp_menu);

	        Menu rtp_menu = new Menu("RTP-Layer");
		        Menu rtp_menu_audio = new Menu("RTP-Audio");
		        	rtp_menu_audio.add("RTP-Lossrate (Audio)");
		        	rtp_menu_audio.add("RTP-Avg Payload Rate (Audio)");
	        	rtp_menu.add(rtp_menu_audio);

	        	Menu rtp_menu_video = new Menu("RTP-Video");
		        	rtp_menu_video.add("RTP-Lossrate (Video)");
		        	rtp_menu_video.add("RTP-Avg Payload Rate (Video)");
	        	rtp_menu.add(rtp_menu_video);
	        m.add(rtp_menu);

	mb.add(m);


        m = new Menu("Graph");
        	m.add("Display file ...");
//        	m.add("Create PostScript ...");
        mb.add(m);


//        m = new Menu("Options");
//	        m.add("Timers");         
//        mb.add(m);

        m = new Menu("Help");
        	m.add("Sorry, no Help supported yet");
	mb.add(m);
        mb.setHelpMenu(m);

        setMenuBar(mb);
        reshape(100,100,500,300);
        show(); 
        
        Config.HOME = System.getProperty("user.dir") + "/";
        saveDialog = new FileDialog( this, "Save Conference...", 
                                       FileDialog.SAVE );

        openDialog = new FileDialog( this, "Open Conference..." );

        conFileHan = new ConferenceFileHandler( this );
    }


    public void set_conference( Conference c )  { act = c; }

    public Conference get_conference()  { return act; }

    public void start_conference()
    {
       if ( act == null ) return;

       if ( Config.CONFERENCE_IS_RUNNING == true ) return ;

       Config.CONFERENCE_IS_RUNNING = true;

       procHan = new ProcessHandler( this );
       procHan.start();
 
       if ( act.get_ip() ) {
         ip_rh = new RuntimeHandler(
              Config.LAYER_IP, Config.AUDIO_AND_VIDEO_CONNECTION, this );
         ip_rh.start();
       }

       if ( act.get_udp()) {
         udp_rh_v = new RuntimeHandler( 
               Config.LAYER_UDP, Config.VIDEO_CONNECTION, this );
         udp_rh_v.start();
       }

       if ( act.get_udp()) {
         udp_rh_a = new RuntimeHandler( 
               Config.LAYER_UDP, Config.AUDIO_CONNECTION, this );
         udp_rh_a.start();
       }

       if ( act.get_rtp()) {
         rtp_rh_v = new RuntimeHandler( 
               Config.LAYER_RTP, Config.VIDEO_CONNECTION, this );
         rtp_rh_v.start();
       }

       if ( act.get_rtp()) {
         rtp_rh_a = new RuntimeHandler( 
               Config.LAYER_RTP, Config.AUDIO_CONNECTION, this );
         rtp_rh_a.start();
       }



    }

    public void stop_conference()
    {
       if ( Config.CONFERENCE_IS_RUNNING == false ) return;

       if ( procHan != null ) { 
         procHan.stop();
         procHan = null;
       }
       if ( ip_rh != null )    { ip_rh.terminate();    ip_rh = null;    }
       if ( udp_rh_v != null ) { udp_rh_v.terminate(); udp_rh_v = null; }
       if ( udp_rh_a != null ) { udp_rh_a.terminate(); udp_rh_a = null; }
       if ( tcp_rh != null )   { tcp_rh.terminate();   tcp_rh = null;   }
       if ( rtp_rh_v != null ) { rtp_rh_v.terminate(); rtp_rh_v = null; }
       if ( rtp_rh_a != null ) { rtp_rh_a.terminate(); rtp_rh_a = null; }
       if ( atm_rh != null )   { atm_rh.terminate();   atm_rh = null;   }
       Config.CONFERENCE_IS_RUNNING = false;
    }


   public boolean handleEvent( Event evt )
   {        
    if (evt.id == Event.WINDOW_DESTROY) {
       System.exit(0);          
       return false;
    } 
    else { return super.handleEvent(evt); }
   }


    public boolean action(Event evt, Object arg)
     {

       if (evt.target instanceof Button ) {

	// Start conference
        if ("Start Conference".equals(arg)) {
          if  (Config.CONFERENCE_IS_RUNNING == false )
            start_conference();
        return true;
        }

	// Stop conference
        if ("Stop Conference".equals(arg)) {                
         if ( Config.CONFERENCE_IS_RUNNING == true ) stop_conference();       
         return true;
        }
        return false;
      }


      if (evt.target instanceof MenuItem ) {

	// The "CONFERENCE" Menu

	  // Create a new Conference
          if ("New".equals(arg)) {                 

            // Only create a new Conference when no other is activ
            if ( act == null ) {
              Conference con = new Conference();
              Editor edi = new Editor( this, con);
            }
            return false;
          }


	  // Edit conference parameters
          if ("Edit".equals(arg))  {
            if ( act != null ) Editor edi = new Editor( this, act );
            return false;
          }


          // Close the conference
          if ("Close".equals(arg)) {               
            if ( act != null ) 
            { 
              conFileHan.close();
            }
           act = null;
           return false;
          }



	// The "FILE" Menu

          // Open a existing conference
          if ("Open".equals(arg)) {
            openDialog.show();
             if ( openDialog.getFile() != null ) {
              conFileHan.open(openDialog.getDirectory(),openDialog.getFile());
              if ( conFileHan.read() ) Editor edi = new Editor(this, act);
            }
            return false;
          }        


          // Save the current conference
          if ("Save".equals(arg)) {
           if ( act != null ) {
            saveDialog.setDirectory(Config.HOME);
            saveDialog.setFile(Config.HOME + act.get_name() + ".dat");
            saveDialog.show();
            if ( saveDialog.getFile() != null ) {
              File f = new File(saveDialog.getDirectory(), 
                    saveDialog.getFile());
              if ( f.exists() ) f.delete();
              f = new File(saveDialog.getDirectory(), saveDialog.getFile());
              if ( conFileHan.open(saveDialog.getDirectory(), 
                    saveDialog.getFile() )) {
                conFileHan.write( act );
              }
            }
           }
          }




	  // Quit the Menu
          if ("Quit".equals(arg)) {                
              System.exit(0);
              return false;
          }


	// The STATISTICS menu

	  if ("ATM-Layer".equals(arg)) {
 	    return false;
          }

	  if ("IP-Interarrival-Time".equals(arg)) {
            if ( ip_rh != null ) ip_rh.showgraph( Config.GRAPH_INTERARRIVAL_TIME );
	    return false;
          }	 
	  if ("IP-Lossrate".equals(arg)) {
            if ( ip_rh != null ) ip_rh.showgraph( Config.GRAPH_LOSSRATE );
	    return false;
          }	 
	  if ("IP-Bandwidth-Usage".equals(arg)) {
            if ( ip_rh != null ) ip_rh.showgraph( Config.GRAPH_BANDWIDTH_USAGE );
	    return false;
          }	 


	  if ("UDP-Interarrival-Time (Audio)".equals(arg)) {
            if ( udp_rh_a != null ) udp_rh_a.showgraph( 
                          Config.GRAPH_INTERARRIVAL_TIME );
	    return false;
          }	 
	  if ("UDP-Bandwidth-Usage (Audio)".equals(arg)) {
            if ( udp_rh_a != null ) udp_rh_a.showgraph( 
                          Config.GRAPH_BANDWIDTH_USAGE );
	    return false;
          }	 

	  if ("UDP-Interarrival-Time (Video)".equals(arg)) {
            if ( udp_rh_v != null ) udp_rh_v.showgraph( 
                          Config.GRAPH_INTERARRIVAL_TIME );
	    return false;
          }	 
	  if ("UDP-Bandwidth-Usage (Video)".equals(arg)) {
            if ( udp_rh_v != null ) udp_rh_v.showgraph( 
                          Config.GRAPH_BANDWIDTH_USAGE );
	    return false;
          }	 


	  if ("RTP-Avg Payload Rate (Audio)".equals(arg)) {
            if ( rtp_rh_a != null ) rtp_rh_a.showgraph( 
                          Config.GRAPH_BANDWIDTH_USAGE );
	    return false;
          }	 
	  if ("RTP-Lossrate (Audio)".equals(arg)) {
            if ( rtp_rh_a != null ) rtp_rh_a.showgraph( 
                          Config.GRAPH_LOSSRATE );
	    return false;
          }	 

	  if ("RTP-Avg Payload Rate (Video)".equals(arg)) {
            if ( rtp_rh_v != null ) rtp_rh_v.showgraph( 
                          Config.GRAPH_BANDWIDTH_USAGE );
	    return false;
          }	 
	  if ("RTP-Lossrate (Video)".equals(arg)) {
            if ( rtp_rh_v != null ) rtp_rh_v.showgraph( 
                          Config.GRAPH_LOSSRATE );
	    return false;
          }	 



       // The GRAPHICS Menu


          // Open a existing conference 
          if ("Display file ...".equals(arg)) {                
            openDialog.show();
            if ( openDialog.getFile() != null ) {
             RealFileHandler rfh = new RealFileHandler( 
                     openDialog.getDirectory() + openDialog.getFile());
            }
            return false;
          }        

       return false;
      }
    return false;
   }
}



class InfoDialog extends Dialog {

    protected Button button;
    protected Label label;

    public InfoDialog( Frame parent, String s ) {
        super(parent, "Information", false);
        setLayout(new BorderLayout());
        label = new Label(s);
        Panel p0 = new Panel();
        p0.setLayout(new FlowLayout());
        p0.add(label);
        add("Center", p0);
        button = new Button("OK");
        Panel p1 = new Panel();
        p1.setLayout(new FlowLayout());
        p1.add(button);
        add("South", p1);
	resize(200,100);
        pack();  
    }

    public void show()
    {
	Rectangle bounds = getParent().bounds();
        Rectangle abounds = bounds();
        move(bounds.x + (bounds.width - abounds.width)/ 2,
             bounds.y + (bounds.height - abounds.height)/2);
        super.show();
    }

    public boolean action(Event e, Object arg) {
        String l = (String)arg;

        if (l.equals("OK")) {
            this.hide();
            this.dispose();
            return true;
        } 
        return false;
    }
}

