package jam;

public final 
class Config {

 // This class needs no instances

 private Config() {};

 // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 // THIS PART OF THE CONFIGURATION FILE MUST BE SPECIFIED BY THE USER
 // ================================================================
 // snoop specific constants

 // Change the INTERFACE variable if neccesary
 public static String INTERFACE		= "pa0";

 // To determine the right interface for the machine, use the command
 // 			netstat -i 
 // which will list all the interfaces the machine has. 
 // If this variable is altered, please recompile this file using the
 // command javac Config.java

 // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 // ---- There shouldn't be anything to modify beyond this line -----

 // To print the rigth timestamps
 public static String TIME_DELAY	= " -td";
 public static String SNOOP_MODE	= "-P";
 public static String SNOOP_STR = "snoop " + SNOOP_MODE +  " -d" + 
				   INTERFACE + TIME_DELAY;



 // The different layer constants
 public static final int LAYER_ATM = 0;
 public static final int LAYER_IP  = 1;
 public static final int LAYER_UDP = 2;
 public static final int LAYER_TCP = 3;
 public static final int LAYER_RTP = 4;


 // The timers for updating graphics ( in Milliseconds )
 public static int CYCLETIME_ATM	=  100;
 public static int CYCLETIME_IP		=  1000; 
 public static int CYCLETIME_UDP	=  1000;
 public static int CYCLETIME_TCP	=  1000;
 public static int CYCLETIME_RTP	=  1000;


 // The number of packets read out of a tempfile
 public static final int MAX_TMP_ATM_PACKETS	=  200;
 public static final int MAX_TMP_IP_PACKETS	=  1000;
 public static final int MAX_TMP_UDP_PACKETS	=  1000;
 public static final int MAX_TMP_TCP_PACKETS	=  1000;
 public static final int MAX_TMP_RTCP_PACKETS	=  1;


 // The different Applications
 public static final int APPLICATION_ZERO   = 0;
 public static final int APPLICATION_MBONE  = 1;
 public static final int APPLICATION_BERKOM = 2;
 public static final int APPLICATION_GROUPX = 3;
 
 public static String APPLICATION_ZERO_STRING   = "No Application";
 public static String APPLICATION_MBONE_STRING  = "MBone Tools";
 public static String APPLICATION_BERKOM_STRING = "Berkom Tools";
 public static String APPLICATION_GROUPX_STRING = "GroupX Tools";


 // The different types of graphs
 public static final int GRAPH_INTERARRIVAL_TIME     = 0;
 public static final int GRAPH_BANDWIDTH_USAGE       = 1;
 public static final int GRAPH_LOSSRATE              = 2;
 

 // Identify either a audio, video connection at UDP layer
 public static final int VIDEO_CONNECTION		= 10;
 public static final int AUDIO_CONNECTION      		= 11;
 // No seperation at IP layer
 public static final int AUDIO_AND_VIDEO_CONNECTION	= 12;


 // The highest IP identification number
 public static final int MAX_IP_SEQ_NO	= 65535;


 // The boolean Variable indicating a running conference
 public static boolean CONFERENCE_IS_RUNNING = false;


 // The beginning string for a shellscript 
 public static String SHELL_SCRIPT_BEGIN      = "#!/bin/sh\n";


 // The directory to where all the output files are written
 // This parameter will be initailized with the working directory
 public static String HOME = "";


 // The names of the scriptfiles for process handling
 public static String PROCESS_START_FILE = "Process.run";
 public static String PROCESS_STOP_FILE  = "Process.stop";


 // The file - appendices for the temporary data-files
 public static String AUDIO_STR = "audio";
 public static String VIDEO_STR = "video";


 // Variables to be used for different purposes
 public static final int START = 0;
 public static final int STOP  = 1;

}
