package jam;

import java.awt.* ;


public class Editor extends Frame
{

   TextField t0,t1,t2,t3,t4;
   Checkbox c0,c1,c2;
   Choice c;
   Label l0,l1,l2,l3,l4,l5,l6 ;
   Button b0,b1,b2;

   Conference con;
   ConferenceMenu parent;

   public Editor( ConferenceMenu m, Conference conf ) 
   {
     super();
     // Save old conference in case of no modification
     con = conf;

     // Get calling ConferenceMenu class
     parent = m;


     // Layout for the Frame
     setLayout( null );

     t0  = new TextField( con.get_name(), 20 ); 	add( t0 );
     t1  = new TextField( con.get_source(), 45 );	add( t1 );
     t2  = new TextField( con.get_destination(), 45 );	add( t2 );
     t3  = new TextField( con.get_video(), 5 );		add( t3 );
     t4  = new TextField( con.get_audio(), 5 );		add( t4 );

     c0 = new Checkbox("IP", null, con.get_ip());	add( c0 );
     c1 = new Checkbox("UDP", null, con.get_udp());   	add( c1 );  
     c2 = new Checkbox("RTP", null, con.get_rtp());	add( c2 );
     
     l0 = new Label("Name : ");  			add( l0 ); 
     l1 = new Label("Application : ");			add( l1 ); 
     l2 = new Label("Local Host : ");			add( l2 );
     l3 = new Label("Connected Host : ");		add( l3 );
     l4 = new Label("Video Port : ");			add( l4 );
     l5 = new Label("Audio Port : ");			add( l5 );
     l6 = new Label("Protocol : ");			add( l6 );

     c = new Choice();
     // Look at application constant values in Config for selection !
     // c.addItem(Config.APPLICATION_ZERO_STRING);
     c.addItem(Config.APPLICATION_MBONE_STRING);
     
     // c.select( con.get_application() );
     add( c );  

     b0 = new Button("Set");add( b0 );
     b1 = new Button("Cancel");add( b1 );
     b2 = new Button("Help");add( b2 );


     // Initialize Editor 
     init();


   }


   public void init( )
   {
     int x1 = 30;
     int x2 = 250;
     int y = 20;
     int h = 30;
     int w = 540;
     setTitle("JAM  -  Conference Editor");

     l0.reshape(x1, 2*y, 150, h );  
     t0.reshape(x2, 2*y, 200, h );     
     l1.reshape(x1, 4*y, 150, h);
      c.reshape(x2, 4*y, 150, h );   
     l2.reshape(x1, 7*y, 150, h);
     t1.reshape(x2, 7*y, 200, h);
     l3.reshape(x1, 9*y, 150, h);  
     t2.reshape(x2, 9*y, 200, h);
     l4.reshape(x1, 11*y,150, h);  
     t3.reshape(x2, 11*y,60, h);
     l5.reshape(x1, 13*y,150, h);
     t4.reshape(x2, 13*y,60, h);
     l6.reshape(x1, 16*y,150, h); 
     c0.reshape(x2, 16*y,50, h);
     c1.reshape(x2+60, 16*y,50, h); 
     c2.reshape(x2+120, 16*y,50, h);

     // The buttons to modify Conference parameters

     b0.reshape( (w-270)/2, 19*y, 70, h); 
     b1.reshape( (w-70)/2 , 19*y, 70, h);
     b2.reshape( (w+130)/2 , 19*y, 70, h);
   
     this.reshape(350,200,w,440);
     this.show();
    }  


   public boolean action( Event evt, Object arg )
   {  

     if (evt.target instanceof Button ) {

      if ("Set".equals( arg )) {
       save();
       parent.set_conference( con );
       return true;
      }
     
     if ("Cancel".equals(arg )) {   
      hide();
      return true;
      }
 
     if ("Help".equals(arg)) {
       return true;
      }
     return false;
    }

    return false;
   }

      
   public boolean handleEvent( Event evt )
   {        
    if (evt.id == Event.WINDOW_DESTROY) {
       hide();          
       return true;
    } 
    else { return super.handleEvent(evt); }
   }


   // This function will save the actual parameter in case the "Set"
   // button has been pressed
   public void save()
   {
      int port_1 = Integer.valueOf(t3.getText()).intValue();
      int port_2 = Integer.valueOf(t4.getText()).intValue();
      port_1 %= 2;
      port_2 %= 2;
      if ( ( port_1 > 0 ) || ( port_2 > 0 ) )
       { 
        InfoDialog d = new InfoDialog(this,"Please select an even port number");
        d.show();
       }
      else {
        con.set_name( t0.getText() );
        con.set_application( Config.APPLICATION_MBONE );
        con.set_source( t1.getText() );
        con.set_destination( t2.getText() );
        con.set_video( t3.getText() );
        con.set_audio( t4.getText() );
        con.set_ip( c0.getState() );
        con.set_udp( c1.getState() );
        con.set_rtp( c2.getState() );
      }
   }
}
