package jam;

import java.awt.*;
import java.util.*;


public class GraphHandler extends Frame {

      G2Dint  graph;
      Label   title;
      DataSet data;
      String  x_titel, 
              y_titel,
              graph_titel,
              frame_titel;
      Axis    xaxis;
      Axis    yaxis;
      int graph_typ, con_typ, layer_typ;
      Color color = Color.blue;

      public GraphHandler( DataSet ds, int g, int c, int l ) 
      {
        data = ds;
        graph_typ = g;
        con_typ   = c;
        layer_typ = l;
        setLayout( new BorderLayout() );
        setLabels();
        setTitle( frame_titel);
 
        graph = new G2Dint();
        graph.borderBottom = 50;
        graph.borderRight  = 50;
        graph.setFont(new Font("TimesRoman",Font.PLAIN,16));
	graph.attachDataSet(data);
        add("Center", graph );

        title = new Label(graph_titel, Label.CENTER);
        title.setFont(new Font("TimesRoman",Font.BOLD,16));
        add("North", title );


        // Specify the data line color

        data.linecolor = color; 

        // Instantiate the xaxis and attach the dataset.
        xaxis = graph.createXAxis();     
	xaxis.attachDataSet(data);
        xaxis.title.setText(x_titel);
        xaxis.title.setColor(color);
        xaxis.title.setFont(new Font("TimesRoman",Font.ITALIC,20));
        xaxis.label.setFont(new Font("Helvetica",Font.PLAIN,16));


        // Instantiate the yaxis and attach the dataset.

        yaxis = graph.createYAxis();
	yaxis.attachDataSet(data);
        yaxis.title.setText(y_titel);
        yaxis.title.setColor(color);
        yaxis.title.setFont(new Font("TimesRoman",Font.ITALIC,20));
        yaxis.label.setFont(new Font("Helvetica",Font.PLAIN,16));

        resize( 500, 400 );

      }

      public boolean handleEvent( Event evt )
      {        
        if (evt.id == Event.WINDOW_DESTROY) {
          hide();          
          return true;
         } 

        else { return super.handleEvent(evt); }

      }

       

      // Shows the graph with the newest data 
      public void actualize()
      {
        graph.repaint();
      }

      
      // Sets the titel and the x,y-titels of the graph
      public void setLabels()
      {
        switch ( layer_typ ) {

          case Config.LAYER_ATM : 
                   frame_titel = "ATM Statistics" ; 
                   color = Color.blue;
                   break;

          case Config.LAYER_IP  : 
                   frame_titel = "IP Statistics" ;  
                   color = Color.red;
                   break;

          case Config.LAYER_UDP : 
                   frame_titel = "UDP Statistics" ;
                   color = Color.blue;
                   break;

          case Config.LAYER_TCP : 
                   frame_titel = "TCP Statistics" ; 
                   color = Color.blue;
                   break;

          case Config.LAYER_RTP : 
                  frame_titel = "RTP Statistics" ; 
                  color = Color.black;
                  break;

          default : graph_titel = " ";
        }

       String con_typ_str = "";
        if ( con_typ == Config.AUDIO_CONNECTION )
         con_typ_str = " ( Audio )";
        else if ( con_typ == Config.VIDEO_CONNECTION )
         con_typ_str = " ( Video )";

        switch ( graph_typ ) {

          case Config.GRAPH_INTERARRIVAL_TIME :
              graph_titel = "Interarrival - Time" + con_typ_str;
              y_titel = "Packets";
              x_titel = "Interarrival-Time (sec)";
              data.linestyle = data.BARLINE;
              break;

          case Config.GRAPH_BANDWIDTH_USAGE :
              if ( layer_typ == Config.LAYER_RTP )
               graph_titel = "Average Payload Rate" + con_typ_str;
              else graph_titel = "Bandwidth Usage" + con_typ_str;
              y_titel = "Kbps";
              x_titel = "Conference-Time (sec)";
              data.linestyle = data.STEPLINE;
              break; 
    
          case Config.GRAPH_LOSSRATE :
              graph_titel = "Loss rate" + con_typ_str;
              y_titel = " ( % ) ";
              x_titel = "Conference-Time (sec)";
              break;
        }
      } 
}
