package jam;

import java.io.*;
import java.lang.*;
import java.net.*;

public class ProcessHandler extends Object
{
    Conference con;
    FileOutputStream fstart, fstop;
    ConferenceMenu menu;


    public ProcessHandler( ConferenceMenu parent ) 
    { 
      menu = parent; 
    }


    public void writefile( int j, String s )
    { 
      int i = s.length();
      byte buf[] = new byte[i];
      s.getBytes(0, i, buf,0);
      try {
        if ( j == Config.STOP ) 
         fstop.write(buf);
        else
         fstart.write(buf);
      } catch ( IOException e) {
         System.out.println("Error when writing Process-file"); 
        }
    }

    public String getInetAddress( String s )
    {
      String address;
      InetAddress inad = null;
      try {
        inad = InetAddress.getByName( s );
        address = inad.toString();
        int i = address.lastIndexOf("/");
        address = address.substring(i+1);
        //System.out.println(address);
        return address;
        
      }
      catch ( Exception e )
      { 
       System.out.println("Couldn't get address for host " + s );
       return s;
      }
    }

    public void start( )
    {
       con = menu.get_conference();

      if ( con == null ) return;

       String src_inet_addr = getInetAddress( con.get_source() );
       String dest_inet_addr = getInetAddress( con.get_destination() );

 
       // Open the file that contains all the processes to be executed

       try {

         fstart = new FileOutputStream(Config.HOME +Config.PROCESS_START_FILE);
         writefile( Config.START, Config.SHELL_SCRIPT_BEGIN );


        // Start the monitoring tools
        if ( con.get_atm() ) {
        }

        if ( con.get_ip() ) {
         String ip = Config.SNOOP_STR + " -s 34  \" ip and host " 
                     + dest_inet_addr + "\" > " 
                     + Config.HOME + con.get_name() + ".ip&\n";
         writefile(Config.START, ip);
        }


        if ( con.get_udp() ) {
         String udp_v = Config.SNOOP_STR + " -s 42  \" udp and host " 
                        + dest_inet_addr + " and port "+ con.get_video()
                        + "\" > "+ Config.HOME + con.get_name() + ".udp."
                        + Config.VIDEO_STR + "&\n";

         String udp_a = Config.SNOOP_STR + " -s 42  \" udp and host " 
                        + dest_inet_addr + " and port "+ con.get_audio()
                        + "\" > "+ Config.HOME + con.get_name() + ".udp."
                        + Config.AUDIO_STR + "&\n";

         writefile(Config.START, udp_v);
         writefile(Config.START, udp_a);
        }

        if ( con.get_tcp() ) {
         String tcp_v = Config.SNOOP_STR + " -s 54  \" tcp and host " 
                        + dest_inet_addr +" and port "+ con.get_video() 
                        + "\" > " + Config.HOME + con.get_name() + ".tcp."
                        + Config.VIDEO_STR +  "&\n";
         String tcp_a = Config.SNOOP_STR + " -s 54  \" tcp and host " 
                        + dest_inet_addr + " and port " +con.get_audio()
                        + "\" > " + Config.HOME + con.get_name() + ".tcp."
                        + Config.AUDIO_STR + "&\n";
         writefile(Config.START, tcp_v);
         writefile(Config.START, tcp_a);
        }


        if ( con.get_rtp() ) {
         String rtp_v = "getrtcp " + src_inet_addr + "/" 
                        + con.get_video()
                        + " > " + Config.HOME + con.get_name() + ".rtp." 
                        + Config.VIDEO_STR + "&\n";

         String rtp_a = "getrtcp " + src_inet_addr + "/" 
                        + con.get_audio()
                        + " > " + Config.HOME + con.get_name() + ".rtp."
                        + Config.AUDIO_STR + "&\n";

         writefile(Config.START, rtp_v);
         writefile(Config.START, rtp_a);
        }


        // Start the applications
         switch ( con.get_application() )
          {
            case  Config.APPLICATION_MBONE: 

                      String vic = "vic " + dest_inet_addr + "/" 
                                   + con.get_video() + "&\n";
                      String vat = "vat -r " + dest_inet_addr + "/" 
                                   + con.get_audio() + "&\n";
                      writefile(Config.START, vic);
                      writefile(Config.START, vat);
                      break;

            case Config.APPLICATION_BERKOM : 
            case Config.APPLICATION_GROUPX :
            case Config.APPLICATION_ZERO   : break;
          }

        fstart.close();

      } catch ( IOException e ) {}

      try {
        Runtime.getRuntime().exec(Config.HOME + Config.PROCESS_START_FILE);
      } 
      catch ( IOException e ) 
      { System.out.println("Cant't start Shell Script " + 
                           Config.HOME + Config.PROCESS_START_FILE ); 
      }

     }

     public void stop()
     {
       String kill;
       try {

         fstop = new FileOutputStream(Config.HOME + Config.PROCESS_STOP_FILE);
         writefile(Config.STOP, Config.SHELL_SCRIPT_BEGIN);


         switch ( con.get_application() ) {

          case Config.APPLICATION_MBONE :

                    kill = "kill -9 `ps -aux | grep -v grep | grep vic " +
                                 "|  awk '{print $2}'` &\n";
                    writefile(Config.STOP, kill);
                    kill = "kill -9 `ps -aux | grep -v grep | grep vat " +
                                 "|  awk '{print $2}'` &\n";
                    writefile(Config.STOP, kill);
                    break;

          case Config.APPLICATION_BERKOM :  

                    break;

          case Config.APPLICATION_GROUPX :
 
                    break;

          case Config.APPLICATION_ZERO :

                    break;

         }

         if ( con.get_atm() ) {
    
          }

         if ( con.get_ip() || con.get_tcp() || con.get_udp() ) {
           kill = "kill -9 `ps -aux | grep -v grep | grep snoop " +
                              "|  awk '{print $2}'` &\n";
           writefile(Config.STOP, kill);
         }
 
         if ( con.get_rtp() ) {
           kill = "kill -9 `ps -aux | grep -v grep | grep getrtcp " + 
                            "| awk '{print $2}'` &\n";
           writefile(Config.STOP, kill);
           }
        
        fstop.close();

       } catch ( IOException e ) {}
 
       try {
        Runtime.getRuntime().exec(Config.HOME + Config.PROCESS_STOP_FILE);
       } catch ( IOException e ) {
         System.out.println("Cant't start Shell Script " + 
                           Config.HOME + Config.PROCESS_STOP_FILE );  }

   }
}