package jam;

import java.io.*;
import java.lang.*;


public class RealFileHandler extends Object
{

  GraphHandler gh;
  RuntimeHandler dummy;
  FileInputStream fin;
  DataSet ds;
  int layer_typ, con_typ, graph_typ;
  int MaxPoints = 1000;

  public RealFileHandler( String file ) {

   try {

     // Open the concerning FileInputStream

     fin = new FileInputStream( file );

     // Read the HeaderInformation from the file for setting the labels
     // and read the complete DataSet

     ds = new DataSet();
     getDataSet();
 
     // Instantiate a GraphHandler

     gh = new GraphHandler(ds, graph_typ, con_typ, layer_typ);
     gh.show();
     gh.actualize();

   } catch ( IOException e ) {
     System.out.println("Error when handling file " + file ); }
 }


 public void getDataSet() {

   int datamax = 2*MaxPoints;
   byte b[] = new byte[50];
   int nbytes = 0;
   double data[] = new double[datamax];
   int size = 0;
   int c;
   boolean ok = true;
   boolean get_grp_typ =false;
   boolean get_lay_typ =false;
   boolean get_con_typ =false;

   try {

    while( ok ) {

      c = fin.read();

      switch (c) {

        case '\n' : case ' ' : case '\t' :
           if ( nbytes > 0 ) {
             String s = new String(b,0,0,nbytes);
             if ( get_grp_typ || get_lay_typ || get_con_typ ) {
                int i = Integer.valueOf(s).intValue();
                if ( get_grp_typ ) { graph_typ = i; get_grp_typ = false; }
                if ( get_con_typ ) { con_typ = i;   get_con_typ = false; }
                if ( get_lay_typ ) { layer_typ = i; get_lay_typ = false; }
             }
             else if ( s.equals("#GRAPH_TYP") )	      { get_grp_typ = true; }
             else if ( s.equals("#CONNECTION_TYP") )  { get_con_typ = true; }
             else if ( s.equals("#LAYER_TYP") )       { get_lay_typ = true; }
             else {
               data[size++] = Double.valueOf(s).doubleValue();
               if( size >= datamax ) {
                 ds.append(data, size/2);
                 size = 0;
               }
             }
             nbytes = 0;
           }
           break;
   
        case -1 :
           ok = false;
           break;
          
        default:

          b[nbytes] = (byte)c;
          nbytes++;
          break;
      }

    }

    if( size > 1 )  ds.append(data, size/2);

   } catch(Exception e) {}
 }
}






































