package jam;

import java.io.*;
import java.lang.*;


public class TempFileHandler extends Object
{

   // The calling object
   RuntimeHandler parent;
 
   // The filename
   String tmp_file;

   // The Stream of data
   RandomAccessFile fin;

   // The current location of the filepointer
   long fpos = 0;

   // The byte - array to keep one line from the input-file
   byte[] line = new byte[200];
 
   // The String to hold one input-line
   String line_str;

   // The counter to avoid array-overflow
   int count;   

   // The indicator for a commend line
   boolean commend = false;


   // The constructor
   public TempFileHandler( RuntimeHandler rh )
   {
    parent = rh;
    tmp_file = parent.tmp_file;
    try { 
     fin = new RandomAccessFile(tmp_file,"r");  
    }
    catch ( IOException e ) { 
     System.out.println("\nFATAL ERROR : Missing file " + tmp_file);
     return;
    }
   }


  public void readfile()
  {
   int i=0;
   count = 0;

   try { 

    while ( true )  {

     int b = fin.read();

     switch ( b ) {

       case '#' :

           commend = true;
           break;

       case '\n' :

         try { 
           fpos = fin.getFilePointer();
           line_str = new String(line, 0, 0, i);
           evalline();          
           i = 0;
           count++;
           // Make sure the following line can be read
           if ( count >  parent.packet_counter-1 )
            return;       
         } 
         catch ( IOException e ) {
           System.out.println("Couldn't hold FilePointer"); 
         } 
         commend = false;
         break;

        case -1 :

          try {
            fin.seek( fpos );
            i = 0;
          } 
          catch ( IOException e ) {
            System.out.println("Couldn't set FilePointer");
          }
          return;

        default :
          if ( !commend ) {
           try { line[i++] = (byte)b;  } 
           catch ( ArrayIndexOutOfBoundsException e ) { 
            commend = true;   // Ignore this line, but should not happen
           }
          }
          break;
     }
    }
   } catch ( IOException e ) { 
      System.out.println("Error when reading file " + tmp_file);
     }
 }



 public double get_timestamp()
 {
   int i = line_str.indexOf(' ');
   if ( i > 0 ) {
    String timestr = line_str.substring( 0, i );
    try { 
      return (Double.valueOf( timestr ).doubleValue());
    }
    catch (NumberFormatException n)  {
      System.out.println("Wrong format " + timestr);
    }
   }
   return -1;
 }


 public int get_len() {

   String lenstr = null;
   int j = -1;
   int i = line_str.indexOf("LEN=");
   if ( i > 0 ) {
    switch ( parent.layer_typ ) {
      case Config.LAYER_IP :  
             j = line_str.indexOf(',', i);
             lenstr = line_str.substring(i+4,j);
             break;
      case Config.LAYER_UDP : 
             lenstr = line_str.substring(i+4);
             break;
    }
    if ( (j > i+4) || (lenstr.length() > 0 ))  {    
      try { 
        return (Integer.valueOf( lenstr ).intValue());
      }
      catch (NumberFormatException n) { 
       System.out.println("Wrong format " + lenstr);
      }
    }
   }
   return -1;
 }



 public int get_id() {

   int i = line_str.indexOf("ID=");
   if ( i > 0 ) {
      String idstr = line_str.substring(i+3);
      try { 
        return (Integer.valueOf( idstr ).intValue());
      }
      catch (NumberFormatException n) { 
       System.out.println("Wrong format " + idstr);
      }
    }
    return -1;
 }


 public int get_bytes() {

   int i = line_str.indexOf("BYTES=");
   if ( i > 0 ) {
    int j = line_str.indexOf(' ', i);
    if ( j > i+6 ) { 
      String byte_str = line_str.substring(i+6,j);
      try { 
        return( Integer.valueOf( byte_str ).intValue() );
      }
      catch (NumberFormatException n) { 
       System.out.println("Wrong format " + byte_str);
      }
     }
    }
    return -1;
 }


public double get_loss() {

   int i = line_str.indexOf("LOSS=");
   if ( i > 0 ) {
      String byte_str = line_str.substring(i+5);
      try { 
        return ( Double.valueOf( byte_str ).doubleValue());
      }
      catch (NumberFormatException n) { 
       System.out.println("Wrong format " + byte_str);
      }
    }
    return -1;
 }



 public void evalline( )
 {
  double time, loss;
  int id, len, bytes;
  line_str = line_str.trim();

  switch ( parent.layer_typ ) {

   case Config.LAYER_ATM :

            break;

   case Config.LAYER_IP :
            time = get_timestamp();
            len  = get_len();
            id   = get_id();         
            parent.accept_packet( new IP_Packet( time, id, len ));
            break;

   case Config.LAYER_UDP : 
            time = get_timestamp();
            len  = get_len();
            parent.accept_packet( new UDP_Packet( time, len ));
            break;

   case Config.LAYER_TCP :

            break;

   case Config.LAYER_RTP :
            time  = get_timestamp();
            bytes = get_bytes();
            loss  = get_loss();
            parent.accept_packet(new RTCP_Packet( time, bytes, loss));
            break;
  }
 }

 public void delete_file()
 {

  try {
   File f = new File(Config.HOME, tmp_file.substring(tmp_file.lastIndexOf("/") + 1));
   boolean b = f.delete();
  }
  catch ( Exception e ) {
   System.out.println("Couldn't delete file " + tmp_file);
  }
 }
}


